%%
%% $Id: appreplayfacility.tex,v 1.5 2003-03-07 10:01:20 baurma Exp $
%%

\section{JNukeReplayFacility}

To allow the automated testing of the replay facility, the code
of the \jreplay application has been out-sourced into a 
single object. \texttt{JNukeReplayFacility} is a static object,
i.e., it does not require a constructor.


%% -----------------------------------------------------------------

\subsection{JNukeReplayFacility\_prepareInstrument}

\code{
void \\
JNukeReplayFacility\_prepareInstrument ( \\
\tab	JNukeObj * instrument, \\
\tab	JNukeObj * tcvec, \\
\tab	JNukeObj * classNames \\
)
}

\subsubsection{Description}

Add the required bytecode instrumentation rules described in 
chapter \ref{ch:jreplay} to a single instrument object that can later be 
used in the \jreplay application.

\subsubsection{Parameters}

\begin{description}
\ttitem{instrument}
	Reference to the instrumentation facility
\ttitem{tcvec}
	Reference to a \texttt{JNukeVector} object storing the
	\texttt{JNukeThreadChange} objects that contains the
	thread replay schedule. Such a vector is 
	returned by the \\
	\texttt{JNukeScheduleFileParser\_parse} method.
\ttitem{classNames}
	Reference to a \texttt{JNukeTaggedSet} with the names
	of the classes to be instrumented. Such a set is 
	returned by the 
	\texttt{JNukeScheduleFileParser\_getClassName}
	function.
\end{description}

\subsubsection{Return value}

None.


%% -----------------------------------------------------------------

\subsection{JNukeReplayFacility\_executeCX}

\code{
int \\
JNukeReplayFacility\_executeCX ( \\
\tab	JNukeMem * mem, \\
\tab	const char *cxfilename, \\
\tab    const char *initclass, \\
\tab	const char *outdir \\
)
}

\subsubsection{Description}

Internalize a thread replay schedule from a file and write
instrumented versions of the class files mentioned in the
file to a specified output directory. This method builds
the very core of the \jreplay application.

\subsubsection{Parameters}

\begin{description}
\ttitem{mem}
	Reference to a memory manager object
\ttitem{cxfilename}
	Pointer to the name of the file containing
	the thread schedule to be replayed.
\ttitem{initclass}
	Optional pointer to the name of the initial class
	to be instrumented. The initial class is
	the class that contains the \texttt{main}
	method of the application. If the class is
	mentioned in the thread replay schedule 
	file, this parameter may be omitted by
	passing a \texttt{NULL} value.
\ttitem{outdir}
	Optional pointer specifying an alternate name
	of the output directory where the instrumented
	class files will be stored.
\end{description}

\subsubsection{Return value}

This function returns \texttt{1} if all classes could be 
successfully instrumented. It returns \texttt{0} in all
other cases.

%% -----------------------------------------------------------------

